/*
	Copyright 2007 Coraid, Inc.

	Author:
	Sam Hopkins
	sah@coraid.com
*/

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/sysctl.h>

void *
stats(void *v)
{
	struct timeval t;
	unsigned long long n, *l = v;

typedef unsigned long long ull;

	if (l == NULL) {
		l = malloc (sizeof *l);
		v = l;
		*l = 0;
	}
	if (gettimeofday(&t, NULL) < 0) {
		perror("gettimeofday failure");
		exit(1);
	}
	n = (ull)t.tv_sec*1000 + (ull)t.tv_usec/1000;
	*l = n - *l;
	return v;
}

void
rawstats(void *v)
{
	unsigned long long *l = v;

	printf("%llu\n", *l);
}

void
cookedstats(void *v, unsigned long long bs, unsigned long long count)
{
	unsigned long long *l = v;
	time_t t = * (time_t *)v;
	unsigned long long kbs;

	if (t == 0) {
		printf("invalid\n");
		return;
	}
	kbs = (bs * count);
	kbs *= 1000;
	kbs /= *l;
	kbs >>= 10;
	printf("%7llu  %4s\n", kbs, "n/a");
}

/* check the total amount of I/O is greater than available memory */
void
memcheck(unsigned long long total)
{
	unsigned long long ram;
	size_t len = sizeof ram;
	int mib[2] = { CTL_HW, HW_MEMSIZE };

	if (sysctl(mib, 2, &ram, &len, NULL, 0) < 0) {
		perror("sysctl HW_MEMSIZE failed");
		return;
	}
	if (ram > total)
		fprintf(stderr, "* warning: total I/O < total ram - throughput reported may not reflect I/O path.\n");
}
