/*
	Copyright 2007 Coraid, Inc.

	Author:
	Sam Hopkins
	sah@coraid.com
*/

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>

void *
stats(void *v)
{
	time_t ct, *t = v;

	if (v == NULL) {
		t = malloc(sizeof *t);
		v = t;
		*t = 0;
	}
	ct = time(0);
	*t = ct - *t;
	return v;
}

void
rawstats(void *v)
{
	time_t t = * (time_t *) v;
	printf("%lu\n", (unsigned long) t);
}

void
cookedstats(void *v, unsigned long long bs, unsigned long long count)
{
	time_t t = * (time_t *)v;
	unsigned long long kbs;

	if (t == 0) {
		printf("invalid\n");
		return;
	}
	kbs = (bs * count);
	kbs /= t;
	kbs >>= 10;
	printf("%7lld  %4s\n", kbs, "n/a");
}

/* check the total amount of I/O is greater than available memory */
void
memcheck(unsigned long long total)
{
	unsigned long long m, n;

	n = sysconf(_SC_PHYS_PAGES);
	if (n < 0) {
		perror("sysconf failure for _SC_PHYS_PAGES");
		return;
	}
	m = n;
	n = sysconf(_SC_PAGESIZE);
	if (n < 0) {
		perror("sysconf failure for _SC_PAGESIZE");
		return;
	}
	m *= n;
	if (m > total)
		fprintf(stderr, "* warning: total I/O < total ram - throughput reported may not reflect I/O path.\n");
}
